{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
	{% endblock begin_javascript_fix %}

	{% block begin_javascript %}
	{{ parent() }}
	{{ modulename }}Obj.prototype = {
		_onButtonClick:function(a){
			var _msg='';
			if(a.alt=='Kasa Çağır'){
				_msg="{{ 'QualityCaseCall.callconfirm'|trans }}";
			}
			var t = this;
			var selectedRecord = t.getSelectedRecord();
			if (selectedRecord !== false) {
				if(t._Timer){
					clearTimeout(t._Timer);
					t._Timer=false;
				}
				mj.message({
					title: mj.lng.glb.winTitleOnay,
					modal : true,
					msg: _msg,
					buttons:['NO','YES'],
					cb:function(el,btn){
						if(btn=='YES'){
							var data =  selectedRecord;
							var id = selectedRecord.id;
							var version = selectedRecord.version;
							var routeName = t.modulename + '-update';
							var route = Routing.getRoute(routeName);
							var pagerParams = (t.grids && t.grids.main && t.grids.main.pbar) ? {
								'pg': t.grids.main.pbar.current,
								'lm': t.grids.main.pbar.limit
							} : {};
							var url = Routing.generate(routeName, id ? mj.apply(pagerParams, {
								'id': id,
								'v': version
							}) : pagerParams);
							if (route && route.methods && route.methods.length>0 && route.methods[0]) {
								t.waitMaskShow();
								data.menuId=t.id;
								$.ajax({
									url: url,
									method: "POST",
									headers: { 
										"Content-Type": "application/json",
										"X-HTTP-Method-Override": route.methods[0] 
									},
									dataType: 'json',
									data: JSON.stringify(data),
									success: function(data, textStatus, jqXHR) {
										t.stores.main.load();
										//t.waitMaskHide();
										//var g=t.grids.main;
										//var idx=g.store.data.getIndex('id',selectedRecord.id);
										//g.store.data.splice(idx,1);
										//g._onLoad();
										//if (t.buttons.confirm) {
										//	t.buttons.confirm.setDisable();
										//}
										//t._Timer = setTimeout(function(){t.grids.main.load();},10000);
									},
									error: function(jqXHR, textStatus, errorThrown) {
										t.waitMaskHide();
										var _msg='';
										if(jqXHR.responseJSON){
											_msg=jqXHR.responseJSON.message + "<br>" + jqXHR.responseJSON.file
										}
										if(jqXHR.responseText){
											_msg=jqXHR.responseText;
										}
										mj.message({
											title: mj.lng.glb.error,
											msg: _msg,
											type: "error",
											html: true
										});
										t._Timer = setTimeout(function(){t.grids.main.load();},t.refreshInterval*1000);
									},
									complete: function(jqXHR, textStatus) {
										//t.waitMaskHide();
									}
								});
							}
						}else{
							t._Timer = setTimeout(function(){t.grids.main.load();},t.refreshInterval*1000);
						}
						el.window.close();
					}
				});
			}
		},
		init : function(){
			var t = this;
			t.refreshInterval = 30;
			{{ modulename }}Obj.superclass.init.call(t);
			t.recordsperpage=10000;
			t.windowButtons.add=false;
			t.windowButtons.edit=false;
			t.windowButtons.delete=false;
			var routeName = t.modulename + '-showall';
			var route = Routing.getRoute(routeName);
			var data = {
				'pg': 1,
				'lm': t.recordsperpage
			};
			var url = Routing.generate(routeName, data);
      t.stores.main.url=url;
			const gridConfig = {
				pbar: new mj.pager({
					pos: 'bottom',
					beforePageText: false,
					limit: t.recordsperpage,
					defaultButtons:false,
					elements:{
						selectLimit:false,
						refresh : true
					}
				}),
				cm: [
					{header: "{{ 'QualityCaseCall.client'|trans }}", dataIndex: 'client', width: 100,filter:'single',alias:'cpd',type:'combo',store:t.extras.clients,operator:'='},
					{header: "{{ 'QualityCaseCall.erprefnumber'|trans }}", dataIndex: 'erprefnumber', width: 100,filter:'single',alias:'cpd',operator:'%.%'},
					{header: "{{ 'QualityCaseCall.opname'|trans }}", dataIndex: 'opname', width: 350,filter:'single',alias:'cpd',operator:'%.%'},
					{header: "{{ 'QualityCaseCall.state'|trans }}", dataIndex: 'state', width: 100}
				]
			};

			t._setGridConfig(gridConfig);

			const formConfig= {
				items: [
					new mj.form.field({
						dataIndex: 'id',
						hidden: true
					}),
					new mj.form.field({
						dataIndex: 'version',
						hidden: true
					})
				]
			};
			t._setFormConfig(formConfig);
			t._Timer = false;
			t.grids.main.store.on("load",function(){
				if(t._Timer){
					clearTimeout(t._Timer);
					t._Timer=false;
				}
				t._Timer = setTimeout(function(){t.grids.main.load();},t.refreshInterval*1000);
			});
					
			t.win.on('beforeclose', function(){clearTimeout(t._Timer);});
			if(typeof t.grids.main.pbar.tbar.addSplitter==='function'){
				t.grids.main.pbar.tbar.addSplitter();
			}
			t.buttons.confirm = t.grids.main.pbar.tbar.addButton({
				alt: "{{ 'QualityCaseCall.call'|trans }}",
				cls: 'btn-sm left',
				iconCls: 'mj-accept',
				scope: t,
				handler: t._onButtonClick
			});
			t.buttons.confirm.setDisable();
			t.grids.main.on('rowclick', function(grid){
				var t = this;
				if (t.buttons.confirm&&grid.selectedRow.data.state==='') {
					t.buttons.confirm.setEnable();
				}
			}, t);
			t.stores.main.on('load', function(){
				var t = this;
				if (t.buttons.confirm) {
					t.buttons.confirm.setDisable();
				}
			},t);

		}
		,editSelectedRecord: function() {
			return;
		}
	};
	{% endblock begin_javascript %}


	{% block begin_default_module %}
	{{ parent() }}
	{% endblock begin_default_module %}



	{% block end_default_module %}
	{{ parent() }}
	{% endblock end_default_module %}


	{% block end_javascript %}
	{{ parent() }}
	{% endblock end_javascript %}


	{% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
	{{ parent() }}
{% endblock body %}
